globalvars = {}       # We will store the calculator's variables here

def lookup(map, name):
    for x,v in map:
        if x==name: return v
    if name not in globalvars.keys(): print 'Undefined:', name
    return globalvars.get(name, 0)

%%
parser Calculator:
    ignore:    "[ \r\t\n]+"

    token int: "[0-9]+"
    token real: "([0-9]+'\.'[0-9]*)|([0-9]*'\.'[0-9]+)"
    token number: "([0-9]+)|(([0-9]+'\.'[0-9]*)|([0-9]*'\.'[0-9]+))"
    token char: "[a-zA-Z]"
    token string: "[0-9]*[a-zA-Z]+([a-zA-Z]|[0-9])*"
    token ref: "'$'?[a-zA-Z][a-zA-Z]?[a-zA-Z]?'$'?[1-9][0-9]?[0-9]?[0-9]?"
    token mulref: "'$'?[a-zA-Z][a-zA-Z]?[a-zA-Z]?'$'?[1-9][0-9]?[0-9]?[0-9]?':''$'?[a-zA-Z][a-zA-Z]?[a-zA-Z]?'$'?[1-9][0-9]?[0-9]?[0-9]?"
    token addop: "[+-]"
    token mulop: "[*/]"
    token expop: "\^"
    token funcname: "[a-zA-Z]+"
    token lpar: "\("
    token rpar: "\)"
    token comma: ","
    token equal: "="
    token empty: ""


    token end: "%"
    token NUM: "[0-9]+"
    token VAR: "[a-zA-Z_]+"

      #    exp -> TERM RESTexp | FUNCTION
      #    RESTexp -> addop TERM RESTexp | $\epsilon$
      #    TERM -> expONENT RESTTERM
      #    RESTTERM -> mulop FACTOR RESTTERM | $\epsilon$
      #    expONENT -> FACTOR RESTexpONENT
      #    RESTexpONENT -> expop FACTOR RESTexpONENT | $\epsilon$
      #    FACTOR -> '(' exp ')' | number | ref


      #    ARG -> (mulref | exp) RESTARG
      #    RESTARG -> ',' (mulref | ref) RESTARG | $\epsilon$
      #    FUNCTION -> 'MIN' '(' ARG ')' | 'MAX' '(' ARG ')' |
      #   'AVG' '(' ARG ')' | 'MED' '(' ARG ')'

      #    FORmulA -> '='exp

    rule GOAL:          FORMULA end                     {{print "finished to parse"}}
    rule EXP:           TERM RESTEXP                    {{print "term restexp"}}
                      | FUNCTION                        {{print "function"}}
    rule RESTEXP:       (addop TERM)*                   {{print "addop term restexp"}}
    rule TERM:          EXPONENT RESTTERM               {{print "exponent restterm"}}
    rule RESTTERM:      (mulop EXPONENT)*               {{print "mulop factor restterm"}}
    rule EXPONENT:      FACTOR RESTEXPONENT             {{print "factor restexp"}}
    rule RESTEXPONENT:  (expop FACTOR)*                 {{print "expop factor restexp"}}
    rule FACTOR:        lpar EXP rpar                   {{print "lpar exp rpar"}}
                      | number                          {{print "number"}}
                      | ref                             {{print "ref"}}
    rule ARG:           (mulref                         {{print "mulref"}}
                      |  EXP)                           {{print "exp"}}
                        (RESTARG)*                      {{print "restarg"}}
    rule RESTARG:       comma ARG                       {{print "comma mulref"}}
    rule FUNCTION:      funcname lpar ARG rpar          {{print "funcname lpar arg rpar"}}
    rule FORMULA:       '='EXP                          {{print "formula"}}

%%
if __name__=='__main__':
    print 'Welcome to the calculator sample for Yapps 2.0.'
    print '  Enter either "<expression>" or "set <var> <expression>",'
    print '  or just press return to exit.  An expression can have'
    print '  local variables:  let x = expr in expr'
    # We could have put this loop into the parser, by making the
    # `goal' rule use (expr | set var expr)*, but by putting the
    # loop into Python code, we can make it interactive (i.e., enter
    # one expression, get the result, enter another expression, etc.)
    while 1:
        s = raw_input('>>> ')
        print s
        parse('GOAL', s)
