globalvars = {}       # We will store the calculator's variables here

def lookup(map, name):
    for x,v in map:
        if x==name: return v
    if name not in globalvars.keys(): print 'Undefined:', name
    return globalvars.get(name, 0)


from string import *
import re
from yappsrt import *

class CalculatorScanner(Scanner):
    patterns = [
        ("'='", re.compile('=')),
        ('[ \r\t\n]+', re.compile('[ \r\t\n]+')),
        ('int', re.compile('[0-9]+')),
        ('real', re.compile("([0-9]+'\\.'[0-9]*)|([0-9]*'\\.'[0-9]+)")),
        ('number', re.compile("([0-9]+)|(([0-9]+'\\.'[0-9]*)|([0-9]*'\\.'[0-9]+))")),
        ('char', re.compile('[a-zA-Z]')),
        ('string', re.compile('[0-9]*[a-zA-Z]+([a-zA-Z]|[0-9])*')),
        ('ref', re.compile("'$'?[a-zA-Z][a-zA-Z]?[a-zA-Z]?'$'?[1-9][0-9]?[0-9]?[0-9]?")),
        ('mulref', re.compile("'$'?[a-zA-Z][a-zA-Z]?[a-zA-Z]?'$'?[1-9][0-9]?[0-9]?[0-9]?':''$'?[a-zA-Z][a-zA-Z]?[a-zA-Z]?'$'?[1-9][0-9]?[0-9]?[0-9]?")),
        ('addop', re.compile('[+-]')),
        ('mulop', re.compile('[*/]')),
        ('expop', re.compile('\\^')),
        ('funcname', re.compile('[a-zA-Z]+')),
        ('lpar', re.compile('\\(')),
        ('rpar', re.compile('\\)')),
        ('comma', re.compile(',')),
        ('equal', re.compile('=')),
        ('empty', re.compile('')),
        ('end', re.compile('%')),
        ('NUM', re.compile('[0-9]+')),
        ('VAR', re.compile('[a-zA-Z_]+')),
    ]
    def __init__(self, str):
        Scanner.__init__(self,None,['[ \r\t\n]+'],str)

class Calculator(Parser):
    def GOAL(self):
        FORMULA = self.FORMULA()
        end = self._scan('end')
        print "finished to parse"

    def EXP(self):
        _token_ = self._peek('funcname', 'lpar', 'number', 'ref')
        if _token_ != 'funcname':
            TERM = self.TERM()
            RESTEXP = self.RESTEXP()
            print "term restexp"
        else:# == 'funcname'
            FUNCTION = self.FUNCTION()
            print "function"

    def RESTEXP(self):
        while self._peek('addop', 'rpar', 'end', 'comma') == 'addop':
            addop = self._scan('addop')
            TERM = self.TERM()
        print "addop term restexp"

    def TERM(self):
        EXPONENT = self.EXPONENT()
        RESTTERM = self.RESTTERM()
        print "exponent restterm"

    def RESTTERM(self):
        while self._peek('mulop', 'addop', 'rpar', 'end', 'comma') == 'mulop':
            mulop = self._scan('mulop')
            EXPONENT = self.EXPONENT()
        print "mulop factor restterm"

    def EXPONENT(self):
        FACTOR = self.FACTOR()
        RESTEXPONENT = self.RESTEXPONENT()
        print "factor restexp"

    def RESTEXPONENT(self):
        while self._peek('expop', 'mulop', 'addop', 'rpar', 'end', 'comma') == 'expop':
            expop = self._scan('expop')
            FACTOR = self.FACTOR()
        print "expop factor restexp"

    def FACTOR(self):
        _token_ = self._peek('lpar', 'number', 'ref')
        if _token_ == 'lpar':
            lpar = self._scan('lpar')
            EXP = self.EXP()
            rpar = self._scan('rpar')
            print "lpar exp rpar"
        elif _token_ == 'number':
            number = self._scan('number')
            print "number"
        else:# == 'ref'
            ref = self._scan('ref')
            print "ref"

    def ARG(self):
        _token_ = self._peek('mulref', 'funcname', 'lpar', 'number', 'ref')
        if _token_ == 'mulref':
            mulref = self._scan('mulref')
            print "mulref"
        else:# in ['funcname', 'lpar', 'number', 'ref']
            EXP = self.EXP()
        print "exp"
        while self._peek('comma', 'rpar') == 'comma':
            RESTARG = self.RESTARG()
        print "restarg"

    def RESTARG(self):
        comma = self._scan('comma')
        ARG = self.ARG()
        print "comma mulref"

    def FUNCTION(self):
        funcname = self._scan('funcname')
        lpar = self._scan('lpar')
        ARG = self.ARG()
        rpar = self._scan('rpar')
        print "funcname lpar arg rpar"

    def FORMULA(self):
        self._scan("'='")
        EXP = self.EXP()
        print "formula"


def parse(rule, text):
    P = Calculator(CalculatorScanner(text))
    return wrap_error_reporter(P, rule)



if __name__=='__main__':
    print 'Welcome to the calculator sample for Yapps 2.0.'
    print '  Enter either "<expression>" or "set <var> <expression>",'
    print '  or just press return to exit.  An expression can have'
    print '  local variables:  let x = expr in expr'
    # We could have put this loop into the parser, by making the
    # `goal' rule use (expr | set var expr)*, but by putting the
    # loop into Python code, we can make it interactive (i.e., enter
    # one expression, get the result, enter another expression, etc.)
    while 1:
        s = raw_input('>>> ')
        print s
        parse('GOAL', s)
